Public Class Form1
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        lstAnimals.AllowDrop = True
        lstFruits.AllowDrop = True
    End Sub

    ' Start a drag.
    Private Sub lst_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles lstFruits.MouseDown, lstAnimals.MouseDown
        Dim lst As ListBox = DirectCast(sender, ListBox)

        If e.Button = Windows.Forms.MouseButtons.Right Then
            Dim index As Integer = lst.IndexFromPoint(e.X, e.Y)
            If index <> ListBox.NoMatches Then
                Dim item As String = lst.Items(index)
                Dim drop_effect As DragDropEffects = _
                    lst.DoDragDrop( _
                        lst.Items(index), _
                        DragDropEffects.Move Or DragDropEffects.Copy)

                ' If it was moved, remove the item from this list.
                If drop_effect = DragDropEffects.Move Then
                    ' See if the user dropped the item in this ListBox
                    ' at a higher position.
                    If lst.Items(index) = item Then
                        ' The item has not moved.
                        lst.Items.RemoveAt(index)
                    Else
                        ' The item has moved.
                        lst.Items.RemoveAt(index + 1)
                    End If
                End If
            End If
        End If
    End Sub

    ' Display the appropriate cursor.
    Private Sub lstFruits_DragOver(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstFruits.DragOver, lstAnimals.DragOver
        Const KEY_CTRL As Integer = 8

        If Not (e.Data.GetDataPresent(GetType(System.String))) Then
            e.Effect = DragDropEffects.None
        ElseIf (e.KeyState And KEY_CTRL) And _
        (e.AllowedEffect And DragDropEffects.Copy) = DragDropEffects.Copy Then
            ' Copy.
            e.Effect = DragDropEffects.Copy
        ElseIf (e.AllowedEffect And DragDropEffects.Move) = DragDropEffects.Move Then
            ' Move.
            e.Effect = DragDropEffects.Move
        End If
    End Sub

    ' Drop the entry in the list.
    Private Sub lstFruits_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles lstFruits.DragDrop, lstAnimals.DragDrop
        If e.Data.GetDataPresent(GetType(System.String)) Then
            If (e.Effect = DragDropEffects.Copy) Or _
            (e.Effect = DragDropEffects.Move) Then
                Dim lst As ListBox = DirectCast(sender, ListBox)
                Dim item As Object = CType(e.Data.GetData(GetType(System.String)), System.Object)
                Dim pt As Point = lst.PointToClient(New Point(e.X, e.Y))
                Dim index As Integer = lst.IndexFromPoint(pt.X, pt.Y)
                If index = ListBox.NoMatches Then
                    lst.Items.Add(item)
                Else
                    lst.Items.Insert(index, item)
                End If
            End If
        End If
    End Sub
End Class
